// Électro-Bidouilleur, Mars 2020
// http://bidouilleur.ca
// Libre de tous droits.

plaque_murale_x_dim = 154;
plaque_murale_y_dim = 20;
plaque_murale_z_dim = 4;

doigt_x_dim = 10;
doigt_y_dim = 2;
doigt_z_dim = 70;

griffe_x_dim = doigt_x_dim;
griffe_y_dim = 5;
griffe_z_dim = 2;

renfort_x_dim = doigt_z_dim * 0.7;
renfort_y_dim = 4;
renfort_z_dim = 2;

trou_montage_diam = 5;

pas_griffes = 16;

// Module qui créé un doight complet 
module doigt_complet()
{
        //  Creation d'un doigts
       translate([-plaque_murale_x_dim/2,-(plaque_murale_y_dim/2),0])
        linear_extrude(height = doigt_z_dim, center = false)
        square(size=[doigt_x_dim, doigt_y_dim] , center = false);
       //  Creation d'une griffe
       translate([-plaque_murale_x_dim/2,-(plaque_murale_y_dim/2 - doigt_y_dim),doigt_z_dim-griffe_z_dim])
        linear_extrude(height = griffe_z_dim, center = false)
        square(size=[griffe_x_dim, griffe_y_dim] , center = false);
       //  Creation d'un renfort vertical
       difference() 
       { 
            translate([doigt_x_dim/2-plaque_murale_x_dim/2,-(plaque_murale_y_dim/2 - doigt_y_dim),0])
             cylinder(h = renfort_x_dim, r1 = renfort_y_dim, r2 = 0);
            translate([-plaque_murale_x_dim/2,-(plaque_murale_y_dim/2 + doigt_y_dim),0])
             linear_extrude(height = doigt_z_dim+0.1, center = true)
             square(size=[doigt_x_dim, doigt_y_dim] , center = false);
       }
//       rotate([0,90,0]);
}


// Début du code principal
rotate([90,0,0])

difference() 
{
    union()
    {
        //  Creation de la plaque murale
        linear_extrude(height = plaque_murale_z_dim, center = true)
         square(size=[plaque_murale_x_dim, plaque_murale_y_dim] , center = true);     
        // Création des doights complets
        for (i = [0 : 1 : 9]) 
        {    
            translate([i*pas_griffes,0,0]) 
             doigt_complet();                // Appelle le module de création d'un doigt complet
        }
    }

    //Soustraction d'un trou de montage
    translate([0, 0, 0])
     cylinder($fn=360,h=plaque_murale_z_dim+1, d=trou_montage_diam, center=true);    
    //Soustraction d'un trou de montage
    translate([plaque_murale_x_dim/2-44.5, 0, 0])
     cylinder($fn=360,h=plaque_murale_z_dim+1, d=trou_montage_diam, center=true);    
    //Soustraction d'un trou de montage
    translate([-(plaque_murale_x_dim/2-44.5), 0, 0])
     cylinder($fn=360,h=plaque_murale_z_dim+1, d=trou_montage_diam, center=true);    
    translate([plaque_murale_x_dim/2-13, 0, 0])
     cylinder($fn=360,h=plaque_murale_z_dim+1, d=trou_montage_diam, center=true);    
    //Soustraction d'un trou de montage
    translate([-(plaque_murale_x_dim/2-13), 0, 0])
     cylinder($fn=360,h=plaque_murale_z_dim+1, d=trou_montage_diam, center=true);    
}

